import type { Element } from './element';
import { LinkedList } from './element';
import EventEmitter from 'eventemitter3';
import type { ObjectGeneratorOptions } from './object-generator';
import type { BSONObject, BSONValue } from './utils';
import type { HadronEJSONOptions } from './utils';
export declare const Events: {
    Cancel: string;
};
export declare class Document extends EventEmitter {
    uuid: string;
    doc: BSONObject;
    cloned: boolean;
    isUpdatable: boolean;
    elements: LinkedList;
    type: 'Document';
    currentType: 'Document';
    cancel(): void;
    constructor(doc: BSONObject, cloned?: boolean);
    apply(doc: BSONObject | Document): void;
    generateObject(options?: ObjectGeneratorOptions): BSONObject;
    generateOriginalObject(options?: ObjectGeneratorOptions): BSONObject;
    generateUpdateUnlessChangedInBackgroundQuery(alwaysIncludeKeys?: BSONObject | null): {
        query: BSONObject;
        updateDoc: {
            $set?: BSONObject;
            $unset?: BSONObject;
        };
    };
    get(key: string): Element | undefined;
    getChild(path: (string | number)[]): Element | undefined;
    getId(): BSONValue;
    getOriginalKeysAndValuesForFieldsThatWereUpdated(alwaysIncludeKeys?: BSONObject | null): BSONObject;
    getOriginalKeysAndValuesForSpecifiedKeys(keys: BSONObject): BSONObject;
    getSetUpdateForDocumentChanges(): BSONObject;
    getStringId(): null | string;
    getUnsetUpdateForDocumentChanges(): BSONObject;
    insertPlaceholder(): Element;
    insertBeginning(key: string | number, value: BSONValue): Element;
    insertEnd(key: string | number, value: BSONValue): Element;
    insertAfter(element: Element, key: string | number, value: BSONValue): Element;
    isAdded(): boolean;
    isModified(): boolean;
    isRemoved(): boolean;
    isRoot(): this is Document;
    next(): void;
    _generateElements(): LinkedList;
    static get Events(): typeof Events;
    static FromEJSON(input: string): Document;
    static FromEJSONArray(input: string): Document[];
    toEJSON(source?: 'original' | 'current', options?: HadronEJSONOptions): string;
}
export default Document;
//# sourceMappingURL=document.d.ts.map